f7397242c7a2435c9e569a2ff920efc09c081f50
[osm/devops.git] / installers / install_osm.sh
1 #!/bin/bash
2 # Copyright 2016 Telefónica Investigación y Desarrollo S.A.U.
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 function usage(){
17 echo -e "usage: $0 [OPTIONS]"
18 echo -e "Install OSM from binaries or source code (by default, from binaries)"
19 echo -e " OPTIONS"
20 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
21 echo -e " --source: install OSM from source code using the latest stable tag"
22 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
23 echo -e " -b master (main dev branch)"
24 echo -e " -b v2.0 (v2.0 branch)"
25 echo -e " -b tags/v1.1.0 (a specific tag)"
26 echo -e " ..."
27 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
28 echo -e " --nat: install only NAT rules"
29 # echo -e " --update: update to the latest stable release or to the latest commit if using a specific branch"
30 echo -e " --showopts: print chosen options and exit (only for debugging)"
31 echo -e " -y: do not prompt for confirmation, assumes yes"
32 echo -e " -h / --help: print this help"
33 }
34
35 #Uninstall OSM: remove containers
36 function uninstall(){
37 echo -e "\nUninstalling OSM"
38 if [ $RC_CLONE ] || [ -n "$TEST_INSTALLER" ]; then
39 $OSM_DEVOPS/jenkins/host/clean_container RO
40 $OSM_DEVOPS/jenkins/host/clean_container VCA
41 $OSM_DEVOPS/jenkins/host/clean_container SO
42 #$OSM_DEVOPS/jenkins/host/clean_container UI
43 else
44 lxc stop RO && lxc delete RO
45 lxc stop VCA && lxc delete VCA
46 lxc stop SO-ub && lxc delete SO-ub
47 fi
48 }
49
50 #Configure NAT rules, based on the current IP addresses of containers
51 function nat(){
52 echo -e "\nChecking required packages: iptables-persistent"
53 dpkg -l iptables-persistent &>/dev/null || ! echo -e " Not installed.\nInstalling iptables-persistent requires root privileges" || \
54 sudo DEBIAN_FRONTEND=noninteractive apt-get -yq install iptables-persistent
55 echo -e "\nConfiguring NAT rules"
56 echo -e " Required root privileges"
57 sudo $OSM_DEVOPS/installers/nat_osm
58 }
59
60 #Update RO, SO and UI:
61 function update(){
62 echo -e "\nUpdating components"
63
64 echo -e " Updating RO"
65 CONTAINER="RO"
66 MDG="RO"
67 INSTALL_FOLDER="/opt/openmano"
68 echo -e " Fetching the repo"
69 lxc exec $CONTAINER -- git -C $INSTALL_FOLDER fetch --all
70 BRANCH=""
71 BRANCH=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status -sb | head -n1 | sed -n 's/^## \(.*\).*/\1/p'|awk '{print $1}' |sed 's/\(.*\)\.\.\..*/\1/'`
72 [ -z "$BRANCH" ] && FATAL "Could not find the current branch in use in the '$MDG'"
73 CURRENT=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status |head -n1`
74 CURRENT_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse HEAD`
75 echo " FROM: $CURRENT ($CURRENT_COMMIT_ID)"
76 # COMMIT_ID either was previously set with -b option, or is an empty string
77 CHECKOUT_ID=$COMMIT_ID
78 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" == "HEAD" ] && CHECKOUT_ID="tags/$LATEST_STABLE_DEVOPS"
79 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" != "HEAD" ] && CHECKOUT_ID="$BRANCH"
80 if [[ $CHECKOUT_ID == "tags/"* ]]; then
81 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-list -n 1 $CHECKOUT_ID`
82 else
83 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse origin/$CHECKOUT_ID`
84 fi
85 echo " TO: $CHECKOUT_ID ($REMOTE_COMMIT_ID)"
86 if [ "$CURRENT_COMMIT_ID" == "$REMOTE_COMMIT_ID" ]; then
87 echo " Nothing to be done."
88 else
89 echo " Update required."
90 lxc exec $CONTAINER -- service osm-ro stop
91 lxc exec $CONTAINER -- git -C /opt/openmano stash
92 lxc exec $CONTAINER -- git -C /opt/openmano pull --rebase
93 lxc exec $CONTAINER -- git -C /opt/openmano checkout $CHECKOUT_ID
94 lxc exec $CONTAINER -- git -C /opt/openmano stash pop
95 lxc exec $CONTAINER -- /opt/openmano/database_utils/migrate_mano_db.sh
96 lxc exec $CONTAINER -- service osm-ro start
97 fi
98 echo
99
100 echo -e " Updating SO and UI"
101 CONTAINER="SO-ub"
102 MDG="SO"
103 INSTALL_FOLDER="" # To be filled in
104 echo -e " Fetching the repo"
105 lxc exec $CONTAINER -- git -C $INSTALL_FOLDER fetch --all
106 BRANCH=""
107 BRANCH=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status -sb | head -n1 | sed -n 's/^## \(.*\).*/\1/p'|awk '{print $1}' |sed 's/\(.*\)\.\.\..*/\1/'`
108 [ -z "$BRANCH" ] && FATAL "Could not find the current branch in use in the '$MDG'"
109 CURRENT=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status |head -n1`
110 CURRENT_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse HEAD`
111 echo " FROM: $CURRENT ($CURRENT_COMMIT_ID)"
112 # COMMIT_ID either was previously set with -b option, or is an empty string
113 CHECKOUT_ID=$COMMIT_ID
114 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" == "HEAD" ] && CHECKOUT_ID="tags/$LATEST_STABLE_DEVOPS"
115 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" != "HEAD" ] && CHECKOUT_ID="$BRANCH"
116 if [[ $CHECKOUT_ID == "tags/"* ]]; then
117 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-list -n 1 $CHECKOUT_ID`
118 else
119 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse origin/$CHECKOUT_ID`
120 fi
121 echo " TO: $CHECKOUT_ID ($REMOTE_COMMIT_ID)"
122 if [ "$CURRENT_COMMIT_ID" == "$REMOTE_COMMIT_ID" ]; then
123 echo " Nothing to be done."
124 else
125 echo " Update required."
126 # Instructions to be added
127 # lxc exec SO-ub -- ...
128 fi
129 echo
130 }
131
132 #Configure VCA, SO and RO with the initial configuration:
133 # RO -> tenant:osm, logs to be sent to SO
134 # VCA -> juju-password
135 # SO -> route to Juju Controller, add RO account, add VCA account
136 function configure(){
137 #Configure components
138 echo -e "\nConfiguring components"
139 . $OSM_DEVOPS/installers/export_ips
140
141 echo -e " Configuring RO"
142 lxc exec RO -- sed -i -e "s/^\#\?log_socket_host:.*/log_socket_host: $SO_CONTAINER_IP/g" /etc/osm/openmanod.cfg
143 lxc exec RO -- service osm-ro restart
144 time=0; step=2; timelength=20; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
145 lxc exec RO -- openmano tenant-delete -f osm >/dev/null
146 RO_TENANT_ID=`lxc exec RO -- openmano tenant-create osm |awk '{print $1}'`
147
148 echo -e " Configuring VCA"
149 JUJU_PASSWD=`date +%s | sha256sum | base64 | head -c 32`
150 echo -e "$JUJU_PASSWD\n$JUJU_PASSWD" | lxc exec VCA -- juju change-user-password
151 JUJU_CONTROLLER_IP=`lxc exec VCA -- lxc list -c 4 |grep eth0 |awk '{print $2}'`
152
153 echo -e " Configuring SO"
154 sudo route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP
155 sudo sed -i "$ i route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP" /etc/rc.local
156 lxc exec SO-ub -- nohup sudo -b -H /usr/rift/rift-shell -r -i /usr/rift -a /usr/rift/.artifacts -- ./demos/launchpad.py --use-xml-mode &
157 time=0; step=30; timelength=300; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
158
159 curl -k --request POST \
160 --url https://$SO_CONTAINER_IP:8008/api/config/config-agent \
161 --header 'accept: application/vnd.yang.data+json' \
162 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
163 --header 'cache-control: no-cache' \
164 --header 'content-type: application/vnd.yang.data+json' \
165 --data '{"account": [ { "name": "osmjuju", "account-type": "juju", "juju": { "ip-address": "'$JUJU_CONTROLLER_IP'", "port": "17070", "user": "admin", "secret": "'$JUJU_PASSWD'" } } ]}'
166
167 curl -k --request PUT \
168 --url https://$SO_CONTAINER_IP:8008/api/config/resource-orchestrator \
169 --header 'accept: application/vnd.yang.data+json' \
170 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
171 --header 'cache-control: no-cache' \
172 --header 'content-type: application/vnd.yang.data+json' \
173 --data '{ "openmano": { "host": "'$RO_CONTAINER_IP'", "port": "9090", "tenant-id": "'$RO_TENANT_ID'" }, "name": "osmopenmano", "account-type": "openmano" }'
174
175 }
176
177 function install_lxd() {
178 lxd init --auto
179 lxd waitready
180 systemctl stop lxd-bridge
181 systemctl --system daemon-reload
182 systemctl enable lxd-bridge
183 systemctl start lxd-bridge
184 }
185
186 function ask_user(){
187 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
188 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
189 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
190 read -e -p "$1" USER_CONFIRMATION
191 while true ; do
192 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
193 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
194 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
195 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
196 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
197 done
198 }
199
200 UNINSTALL=""
201 DEVELOP=""
202 NAT=""
203 UPDATE=""
204 RECONFIGURE=""
205 TEST_INSTALLER=""
206 LXD=""
207 SHOWOPTS=""
208 COMMIT_ID=""
209 ASSUME_YES=""
210 INSTALL_FROM_SOURCE=""
211
212 while getopts ":hy-:b:" o; do
213 case "${o}" in
214 h)
215 usage && exit 0
216 ;;
217 b)
218 COMMIT_ID=${OPTARG}
219 ;;
220 -)
221 [ "${OPTARG}" == "help" ] && usage && exit 0
222 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && continue
223 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
224 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
225 [ "${OPTARG}" == "nat" ] && NAT="y" && continue
226 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
227 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
228 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
229 [ "${OPTARG}" == "lxd" ] && LXD="y" && continue
230 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
231 echo -e "Invalid option: '--$OPTARG'\n" >&2
232 usage && exit 1
233 ;;
234 \?)
235 echo -e "Invalid option: '-$OPTARG'\n" >&2
236 usage && exit 1
237 ;;
238 y)
239 ASSUME_YES="y"
240 ;;
241 *)
242 usage && exit 1
243 ;;
244 esac
245 done
246
247 if [ -n "$SHOWOPTS" ]; then
248 echo "DEVELOP=$DEVELOP"
249 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
250 echo "UNINSTALL=$UNINSTALL"
251 echo "NAT=$NAT"
252 echo "UPDATE=$UPDATE"
253 echo "RECONFIGURE=$RECONFIGURE"
254 echo "TEST_INSTALLER=$TEST_INSTALLER"
255 echo "LXD=$LXD"
256 echo "SHOWOPTS=$SHOWOPTS"
257 echo "Install from specific refspec (-b): $COMMIT_ID"
258 exit 0
259 fi
260
261 [ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
262 [ -n "$COMMIT_ID" ] && INSTALL_FROM_SOURCE="y"
263
264 if [ -n "$TEST_INSTALLER" ]; then
265 echo -e "\nUsing local devops repo for OSM installation"
266 TEMPDIR="$(dirname $(realpath $(dirname $0)))"
267 else
268 echo -e "\nCreating temporary dir for OSM installation"
269 TEMPDIR="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
270 trap 'rm -rf "$TEMPDIR"' EXIT
271 fi
272
273 echo -e "Checking required packages: git"
274 dpkg -l git &>/dev/null || ! echo -e " git not installed.\nInstalling git requires root privileges" || sudo apt-get install -y git
275 if [ -z "$TEST_INSTALLER" ]; then
276 echo -e "\nCloning devops repo temporarily"
277 git clone https://osm.etsi.org/gerrit/osm/devops.git $TEMPDIR
278 RC_CLONE=$?
279 fi
280
281 echo -e "\nGuessing the current stable release"
282 LATEST_STABLE_DEVOPS=`git -C $TEMPDIR tag -l v[0-9].* | tail -n1`
283 [ -z "$COMMIT_ID" ] && [ -z "$LATEST_STABLE_DEVOPS" ] && echo "Could not find the current latest stable release" && exit 0
284 echo "Latest tag in devops repo: $LATEST_STABLE_DEVOPS"
285 [ -z "$COMMIT_ID" ] && [ -n "$LATEST_STABLE_DEVOPS" ] && COMMIT_ID="tags/$LATEST_STABLE_DEVOPS"
286 [ -z "$TEST_INSTALLER" ] && git -C $TEMPDIR checkout tags/$LATEST_STABLE_DEVOPS
287
288 OSM_DEVOPS=$TEMPDIR
289 OSM_JENKINS="$TEMPDIR/jenkins"
290 . $OSM_JENKINS/common/all_funcs
291
292 [ -n "$UNINSTALL" ] && uninstall && echo -e "\nDONE" && exit 0
293 [ -n "$NAT" ] && nat && echo -e "\nDONE" && exit 0
294 [ -n "$UPDATE" ] && update && echo -e "\nDONE" && exit 0
295 [ -n "$RECONFIGURE" ] && configure && echo -e "\nDONE" && exit 0
296
297 #Installation starts here
298 echo -e "\nInstalling OSM from refspec: $COMMIT_ID"
299 if [ -n "$INSTALL_FROM_SOURCE" ] && [ -z "$ASSUME_YES" ]; then
300 ! ask_user "The installation will take about 75-90 minutes. Continue (Y/n)? " y && echo "Cancelled!" && exit 1
301 fi
302
303 echo -e "\nChecking required packages: wget, curl, tar"
304 dpkg -l wget curl tar &>/dev/null || ! echo -e " One or several packages are not installed.\nInstalling required packages\n Root privileges are required" || sudo apt-get install -y wget curl tar
305
306 echo -e "Checking required packages: lxd"
307 lxd --version &>/dev/null || FATAL "lxd not present, exiting."
308 [ -n "$LXD" ] && echo -e "\nConfiguring lxd" && install_lxd
309
310 wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README.txt &> /dev/null
311
312 if [ -z "$INSTALL_FROM_SOURCE" ]; then
313 echo -e "\nCreating the containers and installing from binaries ..."
314 $OSM_DEVOPS/jenkins/host/install RO || FATAL "RO install failed"
315 $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA install failed"
316 $OSM_DEVOPS/jenkins/host/install SO || FATAL "SO install failed"
317 $OSM_DEVOPS/jenkins/host/install UI || FATAL "UI install failed"
318 else #install from source
319 echo -e "\nCreating the containers and building from source ..."
320 $OSM_DEVOPS/jenkins/host/start_build RO --notest checkout $COMMIT_ID || FATAL "RO container build failed (refspec: '$COMMIT_ID')"
321 $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA container build failed"
322 $OSM_DEVOPS/jenkins/host/start_build SO checkout $COMMIT_ID || FATAL "SO container build failed (refspec: '$COMMIT_ID')"
323 $OSM_DEVOPS/jenkins/host/start_build UI checkout $COMMIT_ID || FATAL "UI container build failed (refspec: '$COMMIT_ID')"
324 fi
325
326 #Install iptables-persistent and configure NAT rules
327 nat
328
329 #Configure components
330 configure
331
332 wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README2.txt &> /dev/null
333 echo -e "\nDONE"